PlanarYUVLuminanceSource (ZXing 3.5.2 API)
Description: declaration: package: com.google.zxing, class: PlanarYUVLuminanceSource

Package com.google.zxing

# Class PlanarYUVLuminanceSource

java.lang.Object
com.google.zxing.LuminanceSource
com.google.zxing.PlanarYUVLuminanceSource

public final class PlanarYUVLuminanceSource extends LuminanceSource
This object extends LuminanceSource around an array of YUV data returned from the camera driver, with the option to crop to a rectangle within the full data. This can be used to exclude superfluous pixels around the perimeter and speed up decoding. It works for any pixel format where the Y channel is planar and appears first, including YCbCr_420_SP and YCbCr_422_SP.

Author:
  dswitkin@google.com (Daniel Switkin)

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `PlanarYUVLuminanceSource(byte[] yuvData, int dataWidth, int dataHeight, int left, int top, int width, int height, boolean reverseHorizontal)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `LuminanceSource`
  `crop(int left, int top, int width, int height)`
  Returns a new object with cropped image data.
  `byte[]`
  `getMatrix()`
  Fetches luminance data for the underlying bitmap.
  `byte[]`
  `getRow(int y, byte[] row)`
  Fetches one row of luminance data from the underlying platform's bitmap.
  `int`
  `getThumbnailHeight()`
  `int`
  `getThumbnailWidth()`
  `boolean`
  `isCropSupported()`
  `int[]`
  `renderThumbnail()`

  ### Methods inherited from class com.google.zxing.LuminanceSource

  `getHeight, getWidth, invert, isRotateSupported, rotateCounterClockwise, rotateCounterClockwise45, toString`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### PlanarYUVLuminanceSource

    public PlanarYUVLuminanceSource(byte[] yuvData, int dataWidth, int dataHeight, int left, int top, int width, int height, boolean reverseHorizontal)

- ## Method Details

  - ### getRow

    public byte[] getRow(int y, byte[] row)
    Description copied from class: `LuminanceSource`
    Fetches one row of luminance data from the underlying platform's bitmap. Values range from 0 (black) to 255 (white). Because Java does not have an unsigned byte type, callers will have to bitwise and with 0xff for each value. It is preferable for implementations of this method to only fetch this row rather than the whole image, since no 2D Readers may be installed and getMatrix() may never be called.
    Specified by:
      `getRow` in class `LuminanceSource`
    Parameters:
      `y` - The row to fetch, which must be in [0,getHeight())
      `row` - An optional preallocated array. If null or too small, it will be ignored. Always use the returned object, and ignore the .length of the array.
    Returns:
      An array containing the luminance data.

  - ### getMatrix

    public byte[] getMatrix()
    Description copied from class: `LuminanceSource`
    Fetches luminance data for the underlying bitmap. Values should be fetched using: `int luminance = array[y * width + x] & 0xff`
    Specified by:
      `getMatrix` in class `LuminanceSource`
    Returns:
      A row-major 2D array of luminance values. Do not use result.length as it may be larger than width * height bytes on some platforms. Do not modify the contents of the result.

  - ### isCropSupported

    public boolean isCropSupported()
    Overrides:
      `isCropSupported` in class `LuminanceSource`
    Returns:
      Whether this subclass supports cropping.

  - ### crop

    public LuminanceSource crop(int left, int top, int width, int height)
    Description copied from class: `LuminanceSource`
    Returns a new object with cropped image data. Implementations may keep a reference to the original data rather than a copy. Only callable if isCropSupported() is true.
    Overrides:
      `crop` in class `LuminanceSource`
    Parameters:
      `left` - The left coordinate, which must be in [0,getWidth())
      `top` - The top coordinate, which must be in [0,getHeight())
      `width` - The width of the rectangle to crop.
      `height` - The height of the rectangle to crop.
    Returns:
      A cropped version of this object.

  - ### renderThumbnail

    public int[] renderThumbnail()

  - ### getThumbnailWidth

    public int getThumbnailWidth()
    Returns:
      width of image from `renderThumbnail()`

  - ### getThumbnailHeight

    public int getThumbnailHeight()
    Returns:
      height of image from `renderThumbnail()`